'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _stringify = require('babel-runtime/core-js/json/stringify');

var _stringify2 = _interopRequireDefault(_stringify);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _toConsumableArray2 = require('babel-runtime/helpers/toConsumableArray');

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _map = require('babel-runtime/core-js/map');

var _map2 = _interopRequireDefault(_map);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _webpack = require('webpack');

var _webpack2 = _interopRequireDefault(_webpack);

var _webpackNodeExternals = require('webpack-node-externals');

var _webpackNodeExternals2 = _interopRequireDefault(_webpackNodeExternals);

var _uglifyjsWebpackPlugin = require('uglifyjs-webpack-plugin');

var _uglifyjsWebpackPlugin2 = _interopRequireDefault(_uglifyjsWebpackPlugin);

var _caseSensitivePathsWebpackPlugin = require('case-sensitive-paths-webpack-plugin');

var _caseSensitivePathsWebpackPlugin2 = _interopRequireDefault(_caseSensitivePathsWebpackPlugin);

var _writeFileWebpackPlugin = require('write-file-webpack-plugin');

var _writeFileWebpackPlugin2 = _interopRequireDefault(_writeFileWebpackPlugin);

var _friendlyErrorsWebpackPlugin = require('friendly-errors-webpack-plugin');

var _friendlyErrorsWebpackPlugin2 = _interopRequireDefault(_friendlyErrorsWebpackPlugin);

var _extractTextWebpackPlugin = require('extract-text-webpack-plugin');

var _extractTextWebpackPlugin2 = _interopRequireDefault(_extractTextWebpackPlugin);

var _utils = require('./utils');

var _combineAssetsPlugin = require('../plugins/combine-assets-plugin');

var _combineAssetsPlugin2 = _interopRequireDefault(_combineAssetsPlugin);

var _pagesPlugin = require('../plugins/pages-plugin');

var _pagesPlugin2 = _interopRequireDefault(_pagesPlugin);

var _dynamicChunksPlugin = require('../plugins/dynamic-chunks-plugin');

var _dynamicChunksPlugin2 = _interopRequireDefault(_dynamicChunksPlugin);

var _findConfig = require('../babel/find-config');

var _findConfig2 = _interopRequireDefault(_findConfig);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var nextDir = _path2.default.join(__dirname, '..', '..', '..', '..');
var nextNodeModulesDir = _path2.default.join(nextDir, 'node_modules');
var nextPagesDir = _path2.default.join(nextDir, 'pages');
var defaultPages = ['_error.js', '_document.js'];
var interpolateNames = new _map2.default(defaultPages.map(function (p) {
  return [_path2.default.join(nextPagesDir, p), 'dist/bundles/pages/' + p];
}));

function babelConfig(dir) {
  var mainBabelOptions = {
    cacheDirectory: true,
    presets: []
  };

  var externalBabelConfig = (0, _findConfig2.default)(dir);
  if (externalBabelConfig) {
    console.log('> Using external babel configuration');
    console.log('> Location: "' + externalBabelConfig.loc + '"');
    // It's possible to turn off babelrc support via babelrc itself.
    // In that case, we should add our default preset.
    // That's why we need to do this.
    var options = externalBabelConfig.options;

    mainBabelOptions.babelrc = options.babelrc !== false;
  } else {
    mainBabelOptions.babelrc = false;
  }

  // Add our default preset if the no "babelrc" found.
  if (!mainBabelOptions.babelrc) {
    mainBabelOptions.presets.push(require.resolve('../babel/preset'));
  }

  return mainBabelOptions;
}

exports.default = function () {
  var _ref2 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee2(dir, _ref) {
    var _this = this;

    var _ref$dev = _ref.dev,
        dev = _ref$dev === undefined ? false : _ref$dev,
        _ref$isServer = _ref.isServer,
        isServer = _ref$isServer === undefined ? false : _ref$isServer,
        buildId = _ref.buildId,
        config = _ref.config;
    var extractCSS, cssLoader, postcssLoader, cssLoaderConfig, babelLoaderOptions, externals, webpackConfig;
    return _regenerator2.default.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            cssLoaderConfig = function cssLoaderConfig() {
              var loader = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;

              return [isServer && !cssLoader.options.modules && 'ignore-loader', isServer && cssLoader.options.modules && cssLoader, isServer && cssLoader.options.modules && postcssLoader, isServer && cssLoader.options.modules && loader].concat((0, _toConsumableArray3.default)(!isServer ? extractCSS.extract({
                use: [cssLoader, postcssLoader, loader].filter(Boolean),
                // Use style-loader in development
                fallback: {
                  loader: 'style-loader',
                  options: {
                    sourceMap: true,
                    importLoaders: 1
                  }
                }
              }) : [])).filter(Boolean);
            };

            extractCSS = new _extractTextWebpackPlugin2.default({
              filename: 'static/style.css',
              disable: dev
            });
            cssLoader = {
              loader: isServer ? 'css-loader/locals' : 'css-loader',
              options: (0, _extends3.default)({
                modules: false,
                minimize: !dev,
                sourceMap: dev,
                importLoaders: 1
              }, config.cssLoaderConfig || {})
            };
            postcssLoader = {
              loader: 'postcss-loader',
              options: {
                plugins: function plugins() {}
              }
            };
            babelLoaderOptions = babelConfig(dir);
            externals = isServer ? [(0, _webpackNodeExternals2.default)({
              modulesDir: nextNodeModulesDir,
              includeAbsolutePaths: true,
              whitelist: [/es6-promise|\.(?!(?:js|json)$).{1,5}$/i]
            }), (0, _webpackNodeExternals2.default)({
              modulesDir: _path2.default.join(dir, 'node_modules'),
              includeAbsolutePaths: true,
              whitelist: [/es6-promise|\.(?!(?:js|json)$).{1,5}$/i]
            })] : [];
            webpackConfig = {
              devtool: dev ? 'cheap-module-source-map' : 'source-map',
              // devtool: 'source-map',
              name: isServer ? 'server' : 'client',
              cache: true,
              profile: true,
              target: isServer ? 'node' : 'web',
              externals: externals,
              context: dir,
              entry: function () {
                var _ref3 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee() {
                  var pages, mainJS, clientConfig;
                  return _regenerator2.default.wrap(function _callee$(_context) {
                    while (1) {
                      switch (_context.prev = _context.next) {
                        case 0:
                          _context.next = 2;
                          return (0, _utils.getPages)(dir, { dev: dev, isServer: isServer });

                        case 2:
                          pages = _context.sent;
                          mainJS = require.resolve('../../../client/next' + (dev ? '-dev' : ''));
                          clientConfig = !isServer ? {
                            'main.js': [].concat((0, _toConsumableArray3.default)(config.clientBootstrap || []), [dev && !isServer && _path2.default.join(__dirname, '..', '..', '..', 'client', 'webpack-hot-middleware-client'), dev && !isServer && _path2.default.join(__dirname, '..', '..', '..', 'client', 'on-demand-entries-client'), mainJS]).filter(Boolean)
                          } : {};
                          return _context.abrupt('return', (0, _extends3.default)({}, clientConfig, pages));

                        case 6:
                        case 'end':
                          return _context.stop();
                      }
                    }
                  }, _callee, _this);
                }));

                function entry() {
                  return _ref3.apply(this, arguments);
                }

                return entry;
              }(),
              output: {
                path: _path2.default.join(dir, '.next', isServer ? 'dist' : ''),
                filename: '[name]',
                libraryTarget: 'commonjs2',
                publicPath: '/_next/webpack/',
                // This saves chunks with the name given via require.ensure()
                chunkFilename: '[name]-[chunkhash].js',
                sourceMapFilename: '[file].map?[contenthash]'
              },
              performance: { hints: false },
              resolve: {
                extensions: ['.js', '.jsx', '.json'],
                modules: [nextNodeModulesDir, 'node_modules'],
                alias: {
                  'next': nextDir,
                  'react-dom': dev ? 'react-dom/cjs/react-dom.development.js' : 'react-dom/cjs/react-dom.production.min.js'
                }
              },
              resolveLoader: {
                modules: [nextNodeModulesDir, 'node_modules', _path2.default.join(__dirname, '..', 'loaders')]
              },
              module: {
                rules: [dev && !isServer && {
                  test: /\.(js|jsx)(\?[^?]*)?$/,
                  loader: 'hot-self-accept-loader',
                  include: [_path2.default.join(dir, 'pages'), nextPagesDir]
                }, dev && !isServer && {
                  test: /\.(js|jsx)(\?[^?]*)?$/,
                  loader: 'react-hot-loader/webpack',
                  exclude: /node_modules/
                }, {
                  test: /\.+(js|jsx)$/,
                  include: [dir],
                  exclude: /node_modules/,
                  use: {
                    loader: 'babel-loader',
                    options: babelLoaderOptions
                  }
                }, {
                  test: /\.css$/,
                  use: cssLoaderConfig()
                }, {
                  test: /\.scss$/,
                  use: cssLoaderConfig('sass-loader')
                }, {
                  test: /\.less$/,
                  use: cssLoaderConfig('less-loader')
                }].filter(Boolean)
              },
              plugins: [
              // Useful when profiling
              // new webpack.ProgressPlugin({
              //   profile: true
              // }),
              // new StatsPlugin(`stats-${isServer ? 'server':'client'}.json`),
              new _webpack2.default.IgnorePlugin(/(precomputed)/, /node_modules.+(elliptic)/), dev && new _webpack2.default.NoEmitOnErrorsPlugin(),
              // dev && new UnlinkFilePlugin(),
              dev && !isServer && new _friendlyErrorsWebpackPlugin2.default(), dev && new _webpack2.default.HotModuleReplacementPlugin(), // Hot module replacement
              dev && new _caseSensitivePathsWebpackPlugin2.default(), // Since on macOS the filesystem is case-insensitive this will make sure your path are case-sensitive
              dev && new _webpack2.default.LoaderOptionsPlugin({
                options: {
                  context: dir,
                  customInterpolateName: function customInterpolateName(url, name, opts) {
                    return interpolateNames.get(this.resourcePath) || url;
                  }
                }
              }), dev && new _writeFileWebpackPlugin2.default({
                exitOnErrors: false,
                log: false,
                // required not to cache removed files
                useHashIndex: false
              }), !dev && new _webpack2.default.IgnorePlugin(/react-hot-loader/), !isServer && !dev && new _uglifyjsWebpackPlugin2.default({
                exclude: /react\.js/,
                parallel: true,
                sourceMap: false,
                uglifyOptions: {
                  compress: {
                    comparisons: false
                  }
                }
              }), new _webpack2.default.DefinePlugin({
                'process.env.NODE_ENV': (0, _stringify2.default)(dev ? 'development' : 'production')
              }), !isServer && new _combineAssetsPlugin2.default({
                input: ['manifest.js', 'react.js', 'commons.js', 'main.js'],
                output: 'app.js'
              }), !dev && new _webpack2.default.optimize.ModuleConcatenationPlugin(), !isServer && extractCSS, !isServer && new _pagesPlugin2.default(), !isServer && new _dynamicChunksPlugin2.default(), !isServer && new _webpack2.default.optimize.CommonsChunkPlugin({
                name: 'commons',
                filename: 'commons.js',
                minChunks: 2
              }), !isServer && new _webpack2.default.optimize.CommonsChunkPlugin({
                name: 'react',
                filename: 'react.js',
                minChunks: function minChunks(module, count) {
                  if (dev) {
                    return false;
                  }

                  if (module.resource && module.resource.includes(_path.sep + 'react-dom' + _path.sep) && count >= 0) {
                    return true;
                  }

                  if (module.resource && module.resource.includes(_path.sep + 'react' + _path.sep) && count >= 0) {
                    return true;
                  }

                  return false;
                }
              }), !isServer && new _webpack2.default.optimize.CommonsChunkPlugin({
                name: 'manifest',
                filename: 'manifest.js'
              })].filter(Boolean)
            };


            if (typeof config.webpack === 'function') {
              webpackConfig = config.webpack(webpackConfig, { dev: dev, isServer: isServer, buildId: buildId, babelLoaderOptions: babelLoaderOptions });
            }

            return _context2.abrupt('return', webpackConfig);

          case 9:
          case 'end':
            return _context2.stop();
        }
      }
    }, _callee2, this);
  }));

  function baseConfig(_x, _x2) {
    return _ref2.apply(this, arguments);
  }

  return baseConfig;
}();